using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace ChartExportImage
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox textBox1;
		private string imageLocation;
		private System.Windows.Forms.Button btnbutton2;
		private System.Windows.Forms.Button btnbutton1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.button1 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.btnbutton2 = new System.Windows.Forms.Button();
			this.btnbutton1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Location = new System.Drawing.Point(24, 16);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.Orientation = System.Windows.Forms.Orientation.Horizontal;
			this.chartControl1.Size = new System.Drawing.Size(504, 304);
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "chartControl1";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(24, 384);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(136, 40);
			this.button1.TabIndex = 1;
			this.button1.Text = "Export Image";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(24, 344);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(504, 20);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "textBox1";
			// 
			// btnbutton2
			// 
			this.btnbutton2.Location = new System.Drawing.Point(216, 384);
			this.btnbutton2.Name = "btnbutton2";
			this.btnbutton2.Size = new System.Drawing.Size(136, 40);
			this.btnbutton2.TabIndex = 3;
			this.btnbutton2.Text = "View Image";
			this.btnbutton2.Click += new System.EventHandler(this.btnbutton2_Click);
			// 
			// btnbutton1
			// 
			this.btnbutton1.Location = new System.Drawing.Point(392, 384);
			this.btnbutton1.Name = "btnbutton1";
			this.btnbutton1.Size = new System.Drawing.Size(136, 40);
			this.btnbutton1.TabIndex = 4;
			this.btnbutton1.Text = "Close";
			this.btnbutton1.Click += new System.EventHandler(this.btnbutton1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 446);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnbutton1,
																		  this.btnbutton2,
																		  this.textBox1,
																		  this.button1,
																		  this.chartControl1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential Chart - Export as Image";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
			imageLocation = Application.ExecutablePath;
			imageLocation = imageLocation.Substring(0, imageLocation.LastIndexOf("\\")) + "\\image.bmp";
			this.textBox1.Text = imageLocation;
		}

		protected void InitializeChartData()
		{
			int numSeries = 1;
			int numPoints = 5;

			Random random = new Random();
			for(int i = 0; i < numSeries; i++)
			{
				ChartSeries series = this.chartControl1.Model.NewSeries("Series " + i);
				for(int j = 0; j < numPoints; j++)
				{
					double[] points = new double[]{random.Next(100, 200), random.Next(400, 500)};
					series.Points.Add(j+1, points);
				}
				
				series.Type = ChartSeriesType.Column;
				series.Text = series.Name;
				this.chartControl1.Series.Add(series);
			}
		}

		private void btnbutton1_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void btnbutton2_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start(this.textBox1.Text);
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Image img = new Bitmap(this.chartControl1.Width, this.chartControl1.Height);
			this.chartControl1.Draw(img);
			img.Save(this.textBox1.Text);
		}
	}
}
